﻿using UnityEngine;

namespace Mod
{
    public class Aura2 : MonoBehaviour
    {

        private GameObject Ruka;

        private GameObject RukaGlow;




        public void Awake()
        {
            Ruka = gameObject;



            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(1.0f, 1.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;
            var glow = ModAPI.CreateLight(transform, Color.blue, 5, 1);
            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;

            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();
            RukaGlow.transform.localRotation = Quaternion.identity;
            RukaSprite.sprite = ModAPI.LoadSprite("textures/rukaudar.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(0f, 0f, 1f);
            RukaSprite.sortingLayerName = "Top";
        }

        public void OnTriggerEnter2D(Collider2D other)
        {
            if(other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                other.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
                other.gameObject.GetComponent<LimbBehaviour>().Frozen = false;
            }
            other.gameObject.SendMessage("Nullificator", SendMessageOptions.DontRequireReceiver);



            if (other.gameObject.GetComponent<LimbBehaviour>().IsAndroid == false)
            {
                other.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            }

        }


        
    }
}