﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Mod
{
    public abstract class why : MonoBehaviour
    {
        public GameObject Ruka;
        public GameObject RukaGlow;
        private BoxCollider2D bc;

        public abstract string powerName();
        public abstract string powerSpriteName();
        public abstract string powerSpriteNameUpg();
        public abstract Color color1();

        public bool upgraded = false;

        public bool IsHeadPower = false;

        public string ret()
        {
            return powerName();
        }


        public virtual void Awake()
        {

            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;
            //RukaGlow.transform.localRotation = Ruka.transform.localRotation;
            RukaGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();



            RukaSprite.sprite = powersprites.spritename(powerSpriteName());

            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = color1();
            RukaSprite.sortingLayerName = "Top";


        }



        public virtual void Nullificator()
        {
            if (upgraded == false)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
                Destroy(this);

            }

        }

        public virtual void upg()
        {
            if (upgraded == false)
            {
                upgraded = true;

                RukaGlow.GetComponent<SpriteRenderer>().sprite = powersprites.spritename(powerSpriteNameUpg());
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.gameObject.AddComponent<ImmortalityBehaviour>();
                }

                ModAPI.CreateParticleEffect("Spark", Ruka.transform.position);
            }
        }

    }

    public class killbeh : why
    {
        public override string powerName()
        {
            return ("acid");
        }

        public override string powerSpriteName()
        {
            return ("rukanormal");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaupg");
        }



        public override Color color1()
        {
            return new Color(0f, 1f, 0f);
        }









        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                if (upgraded == false)
                {
                    other.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.4f;
                }
                else
                {


                    other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 1.4f);
                }

            }




        }

        public void FixedUpdate()
        {


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }


        }


        public void rev()
        {
            if (upgraded == false)
            {


                Ruka.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 1.4f);

            }

        }

    }


    //------//

    public class killbeh2 : why
    {
        public override string powerName()
        {
            return ("gold");
        }
        public override string powerSpriteName()
        {
            return ("rukanormal");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaupg");
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 0f);
        }



        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            other.gameObject.TryGetComponent(out NoSleep7 hate);
            if (rb.velocity.magnitude >= 3f)
            {
                if ((hate == null || hate.power < 2) && other.gameObject.GetComponent<Undraggable>() == null)
                {

                    other.gameObject.GetComponent<LimbBehaviour>().Frozen = true;
                    other.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.9f, 0f, 1f);
                    other.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                }
                if (upgraded == true)
                {

                    other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("GoldInfection"), 1.4f);
                }
            }

        }

        public void FixedUpdate()
        {


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0f);
            }


        }
        private void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().Frozen = true;
                    i.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.9f, 0f, 1f);
                    i.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                }

            }

        }


    }

    public class killbeh4 : why
    {
        public override string powerName()
        {
            return ("crusher");
        }

        public override Color color1()
        {
            return new Color(0.5f, 0.2f, 0.8f);
        }
        public override string powerSpriteName()
        {
            return ("braslet");
        }
        public override string powerSpriteNameUpg()
        {
            return ("brasletupg");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            other.gameObject.TryGetComponent(out NoSleep7 hate);
            if (rb.velocity.magnitude >= 3f)
            {
                if ((hate == null || hate.power < 1) && other.gameObject.GetComponent<Undraggable>() == null)
                {

                    other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 2;
                    other.gameObject.GetComponent<LimbBehaviour>().BreakBone();
                    other.gameObject.GetComponent<LimbBehaviour>().Wince(20f);
                    other.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
                }
                if (upgraded == true)
                {
                    other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 6;
                }



            }

        }
        private void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<Rigidbody2D>().velocity = Ruka.gameObject.GetComponent<Rigidbody2D>().velocity * -2;
                    i.gameObject.GetComponent<LimbBehaviour>().BreakBone();
                    i.gameObject.GetComponent<LimbBehaviour>().Wince(20f);
                    i.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
                }

            }

        }

        public void FixedUpdate()
        {


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, 0f);
            }


        }



    }

    public class Electro : why
    {
        public override string powerName()
        {
            return ("electro");
        }

        public override Color color1()
        {
            return new Color(0.2f, 0.2f, 1f);
        }
        public override string powerSpriteName()
        {
            return ("braslet");
        }
        public override string powerSpriteNameUpg()
        {
            return ("brasletupg");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();

            if (rb.velocity.magnitude >= 3f && other.gameObject.GetComponent<Undraggable>() == null)
            {


                other.gameObject.GetComponent<PhysicalBehaviour>().charge += 7f;

                if (upgraded == true)
                {
                    other.gameObject.GetComponent<PhysicalBehaviour>().charge += 80f;
                }



            }

        }
        private void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<PhysicalBehaviour>().charge += 125f;
                }

            }

        }

        public void FixedUpdate()
        {


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.2f, 0.2f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, 0f);
            }


        }



    }

    public class elecshoot : CanShoot
    {

        private GameObject Ruka;
        private GameObject RukaGlow;
        private PhysicalBehaviour physicalBehaviour;
        private Vector2 barrelPosition = new Vector2(0f, 0f);
        private Vector2 barrelDirection = new Vector2(8, -1);

        bool upgr = false;

        private LineRenderer beam;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;

        private bool ready;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];


        private void Nullificator()
        {
            if (upgr == false)
            {
                Destroy(this);

            }

        }


        public void Start()
        {
            Ruka = gameObject;
            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = new Vector3(1f, 1f);

            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();
            RukaGlow.transform.localRotation = Quaternion.identity;
            RukaSprite.sprite = powersprites.eye2;
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(0.5f, 0.2f, 0.8f, 0f);
            RukaSprite.sortingLayerName = "Top";

            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            beam = components.AddComponent<LineRenderer>();
            beam.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            beam.useWorldSpace = false;
            beam.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            beam.sortingLayerName = "Bottom";


            beam.enabled = false;

            ready = true;



        }
        public void Use() => Shoot();


        public override void Shoot()
        {
            var pos = BarrelPosition;
            var dir = BarrelDirection;



            if (ready == true && upgr == true)
            {
                StartCoroutine(Fire());
            }







        }


        private void upg()
        {
            if (upgr == false)
            {
                upgr = true;
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, 0.3f);
                ModAPI.Notify("Use Head to shoot laser beam");
                ModAPI.CreateParticleEffect("Spark", Ruka.transform.position);
            }
        }



        private IEnumerator Fire()
        {
            const int iterations = 8;
            const float duration = 0.5f;

            const float interval = duration / iterations;

            beam.startColor = new Color(0.5f, 0.2f, 0.8f, 0.1f);
            beam.endColor = new Color(0.5f, 0.2f, 0.8f, 0.01f);
            beam.widthMultiplier = 0.1f;



            ready = false;
            beam.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 20000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 20000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                beam.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                    var victim = victimBuffer[n];

                    ModAPI.CreateParticleEffect("Spark", victim.point);




                    victim.transform.TryGetComponent(out PhysicalBehaviour ph);
                    ph.charge += 10;




                }

                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(-0.1f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            beam.enabled = false;
            yield return new WaitForSeconds(0.6f);
            ready = true;
        }















        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }


    }






    public class killbeh5 : why
    {
        public override string powerName()
        {
            return ("champion");
        }
        private float time = 1;
        public override Color color1()
        {
            return new Color(0.5f, 0.2f, 0.8f);
        }
        public override string powerSpriteName()
        {
            return ("braslet");
        }
        public override string powerSpriteNameUpg()
        {
            return ("brasletupg");
        }




        public override void Awake()
        {
            base.Awake();
            StartCoroutine(lechenie());

        }

        public void OnCollisionEnter2D(Collision2D other)
        {


            var rb = Ruka.GetComponent<Rigidbody2D>();
            other.gameObject.TryGetComponent(out NoSleep7 hate);


            if (rb.velocity.magnitude >= 2f)
            {
                if ((hate == null || hate.power < 2) && other.gameObject.GetComponent<Undraggable>() == null)
                {
                    other.gameObject.GetComponent<LimbBehaviour>().BreakBone();
                    other.gameObject.GetComponent<LimbBehaviour>().Wince(20f);
                    other.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
                    Destroy(other.gameObject, 1);

                }
                if (upgraded == true)
                {
                    foreach (var i in other.transform.root.GetComponentsInChildren<LimbBehaviour>())
                    {
                        i.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("???"), 1.4f);
                    }


                }
            }





        }
        private void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().BreakBone();
                    i.gameObject.GetComponent<LimbBehaviour>().Wince(20f);
                    i.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
                    Destroy(i.gameObject, 1);
                }

            }

        }




        private IEnumerator lechenie()
        {
            while (true)
            {
                Color newColor = new Color(
UnityEngine.Random.value,
UnityEngine.Random.value,
UnityEngine.Random.value,
0.20f

);
                while (this.gameObject.activeInHierarchy && RukaGlow.GetComponent<SpriteRenderer>().color != newColor)
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = Color.Lerp(RukaGlow.GetComponent<SpriteRenderer>().color, newColor, Time.deltaTime * 10f);
                    yield return new WaitForEndOfFrame();
                }
                yield return new WaitForSeconds(time);
            }



        }



    }
    public class Firebeh : why
    {
        public override string powerName()
        {
            return ("Flamemode");
        }
        public override Color color1()
        {
            return new Color(0.88f, 0.34f, 0.13f);
        }
        public override string powerSpriteName()
        {
            return ("rukanormal");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaupg");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f & other.gameObject.GetComponent<LimbBehaviour>() != null)
            {

                other.gameObject.GetComponent<PhysicalBehaviour>().Ignite();
                //other.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = 1f;
                other.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 60f;
            }

            if (upgraded == true)
            {
                other.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 400f;
            }

        }

        public void FixedUpdate()
        {

            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.88f, 0.34f, 0.13f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }


        }


    

        private void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<PhysicalBehaviour>().Properties.Flammability = 1f;
                    i.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = 1f;
                    i.gameObject.GetComponent<LimbBehaviour>().Wince(20f);

                }

            }

        }

    }
    public class Heal : why
    {
        public override string powerName()
        {
            return ("Healmode");
        }
        public override Color color1()
        {
            return new Color(0.5f, 0.5f, 0.5f);
        }
        public override string powerSpriteName()
        {
            return ("braslet2");
        }
        public override string powerSpriteNameUpg()
        {
            return ("braslet2");
        }

        private BoxCollider2D bc;
        void Start()
        {
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(1.0f, 1.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;
        }

        public void OnTriggerEnter2D(Collider2D other)
        {
            other.gameObject.TryGetComponent(out LimbBehaviour dr);

            if (other.gameObject.GetComponent<HealBeh>() == null)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.5f, 0.5f, 0.25f);
                dr.HealBone();
                dr.Health = dr.InitialHealth;
                dr.Numbness = 0f;
                dr.CirculationBehaviour.HealBleeding();
                dr.CirculationBehaviour.IsPump = dr.CirculationBehaviour.WasInitiallyPumping;
                dr.CirculationBehaviour.BloodFlow = 5f;
                if (dr.CirculationBehaviour.GetAmount(dr.GetOriginalBloodType()) <= 1f)
                {
                    dr.CirculationBehaviour.AddLiquid(dr.GetOriginalBloodType(), 1.4f);
                }

                dr.BruiseCount = 0;
                dr.CirculationBehaviour.GunshotWoundCount = 0;
                dr.CirculationBehaviour.StabWoundCount = 0;

                dr.Person.Consciousness = 1f;
                dr.Person.ShockLevel = 0f;
                dr.Person.PainLevel = 0f;
                dr.Person.OxygenLevel = 1f;
                dr.Person.AdrenalineLevel = 1f;


                if (dr.PhysicalBehaviour.BurnProgress > 0.1f)
                {
                    dr.PhysicalBehaviour.BurnProgress -= 0.66f;
                }

                if (dr.SkinMaterialHandler.AcidProgress > 0.1f)
                {
                    dr.SkinMaterialHandler.AcidProgress -= 0.66f;
                }

                if (dr.SkinMaterialHandler.RottenProgress > 0.1f)
                {
                    dr.SkinMaterialHandler.RottenProgress -= 0.66f;
                }
                while ((double)((IEnumerable<Vector4>)dr.SkinMaterialHandler.damagePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
                {
                    for (int index = 0; index < dr.SkinMaterialHandler.damagePoints.Length; ++index)
                        dr.SkinMaterialHandler.damagePoints[index].z += 0.66f;
                    dr.SkinMaterialHandler.Sync();
                }
                if (upgraded && dr.gameObject.GetComponent<NoSleep7>() == null || dr.gameObject.GetComponent<NoSleep7>().power < 1)
                {
                    dr.gameObject.AddComponent<NoSleep7>().power = 0;
                }
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.5f, 0.5f, 0f);
            }




        }


    }

    public class dualheal : why
    {
        public override string powerName()
        {
            return ("dheal");
        }
        public override Color color1()
        {
            return new Color(0f, 1f, 0f);
        }
        public override string powerSpriteName()
        {
            return ("puncho");
        }
        public override string powerSpriteNameUpg()
        {
            return ("puncho");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            var dr = other.gameObject.GetComponent<LimbBehaviour>();


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                dr.HealBone();
                dr.Health = dr.InitialHealth;
                dr.Numbness = 0f;
                dr.CirculationBehaviour.HealBleeding();
                dr.CirculationBehaviour.IsPump = dr.CirculationBehaviour.WasInitiallyPumping;
                dr.CirculationBehaviour.BloodFlow = 5f;
                if (dr.CirculationBehaviour.GetAmount(dr.GetOriginalBloodType()) <= 1f)
                {
                    dr.CirculationBehaviour.AddLiquid(dr.GetOriginalBloodType(), 1.4f);
                }
                dr.BruiseCount = 0;
                dr.CirculationBehaviour.GunshotWoundCount = 0;
                dr.CirculationBehaviour.StabWoundCount = 0;

                dr.Person.Consciousness = 1f;
                dr.Person.ShockLevel = 0f;
                dr.Person.PainLevel = 0f;
                dr.Person.OxygenLevel = 1f;
                dr.Person.AdrenalineLevel = 1f;
                dr.SkinMaterialHandler.RottenProgress = 0f;
                dr.SkinMaterialHandler.AcidProgress = 0f;
                dr.PhysicalBehaviour.BurnProgress = 0f;
            }



        }

        public void FixedUpdate()
        {

            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }
        }


    }

    public class dualkill : why
    {
        public override string powerName()
        {
            return ("killmode");
        }
        public override Color color1()
        {
            return new Color(1f, 0f, 0f);
        }
        public override string powerSpriteName()
        {
            return ("puncho");
        }
        public override string powerSpriteNameUpg()
        {
            return ("puncho");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            var dr = other.gameObject.GetComponent<LimbBehaviour>();


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                dr.Health = 0f;
            }



        }

        public void FixedUpdate()
        {


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }


        }
        private void rev()
        {


            foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                i.gameObject.GetComponent<LimbBehaviour>().Health = 0f;

            }

        }

    }









    class Explo : why
    {
        public override string powerName()
        {
            return ("explo");
        }
        public override Color color1()
        {
            return new Color(0.7f, 0.1f, 0.1f);
        }
        public override string powerSpriteName()
        {
            return ("puncho");
        }
        public override string powerSpriteNameUpg()
        {
            return ("puncho");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                if (other.gameObject.GetComponent<Undraggable>() == null && other.gameObject.GetComponent<NoSleep7>() == null || other.gameObject.GetComponent<NoSleep7>().power < 2)
                {



                    other.gameObject.AddComponent<ExpBoom>();
                }
                if (upgraded == true)
                {
                    foreach (var i in other.transform.root.GetComponentsInChildren<LimbBehaviour>())
                    {
                        i.gameObject.AddComponent<ExpBoom>();
                    }
                }
            }
        }
        private void Use()
        {
            var items = Global.main.PhysicalObjectsInWorld.ToArray();
            for (int i = 0; i < Global.main.PhysicalObjectsInWorld.Count; i++)
            {
                items[i].SendMessage("BoomTrigger");
            }
        }

        private void rev()
        {
            if (upgraded == false)
            {
                ExplosionCreator.CreatePulseExplosion(transform.position, 0.1f, 0.1f, true, true);
                GameObject.Destroy(gameObject);
            }

        }
    }

    class ExpBoom : MonoBehaviour
    {
        void Start()
        {
            this.gameObject.GetComponent<SpriteRenderer>().color = new Color(0.7f, 0.1f, 0.1f);
        }
        void BoomTrigger()
        {
            ExplosionCreator.CreatePulseExplosion(transform.position, 0.1f, 0.1f, true, true);
            GameObject.Destroy(gameObject);
        }
    }





    public class end : why
    {

        public override string powerName()
        {
            return ("staitc");
        }
        private LightSprite glow;

        public override Color color1()
        {
            return new Color(0.8f, 0.5f, 0.2f);
        }

        public override string powerSpriteName()
        {
            return ("rukanormal");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaupg");
        }



        private Rigidbody2D rb;


        void Start()
        {
            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(3.0f, 3.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;
        }


        public void OnTriggerEnter2D(Collider2D other)
        {
            other.gameObject.TryGetComponent(out NoSleep7 hate);
            if ((hate == null || hate.power < 1) && other.gameObject.GetComponent<Undraggable>() == null)
            {

                other.gameObject.GetComponent<Rigidbody2D>().velocity = Vector2.zero;
            }
            if (upgraded & other.gameObject.GetComponent<TimePoisonBehaviour>() == null & other.gameObject.GetComponent<ImmortalityBehaviour>() == null)
            {
                other.gameObject.AddComponent<TimePoisonBehaviour>();

            }





        }




        private void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    Ruka.gameObject.AddComponent<TimePoisonBehaviour>();
                }




            }

        }





    }










    public class GunBeh : CanShoot
    {

        private GameObject Ruka;
        private PhysicalBehaviour physicalBehaviour;
        private GameObject RukaGlow;
        private Vector2 barrelPosition = new Vector2(0f, 0f);
        private Vector2 barrelDirection = new Vector2(0, -1);
        public bool upgraded = false;
        private LineRenderer beam;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;



        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];



        public void Start()
        {
            Ruka = gameObject;
            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;
            RukaGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = powersprites.gun;
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 1f, 1f, 0.1f);
            RukaSprite.sortingLayerName = "Top";
            Ruka = gameObject;
            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            beam = components.AddComponent<LineRenderer>();
            beam.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            beam.useWorldSpace = false;
            beam.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            beam.sortingLayerName = "Background";
            beam.startColor = Color.red;
            beam.endColor = Color.red;
            beam.widthMultiplier = 0.1f;
            beam.enabled = false;



        }
        private void Use()
        {
            Shoot();
        }


        public override void Shoot()
        {
            var pos = BarrelPosition;
            var dir = BarrelDirection;
            if (upgraded == false)
            {
                physicalBehaviour.rigidbody.AddForceAtPosition(dir * -2, pos, ForceMode2D.Impulse);
                var bolt = new GameObject("pellet", typeof(GunBehBolt));
                bolt.transform.position = pos;
                bolt.transform.right = dir;
                bolt.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
                CameraShakeBehaviour.main.Shake(.5f, pos);
            }
            else
            {
                StartCoroutine(Fire());

            }


        }




        private IEnumerator Fire()
        {
            const int iterations = 8;
            const float duration = 0.5f;

            const float interval = duration / iterations;

            beam.startColor = Color.magenta;
            beam.endColor = Color.magenta;
            beam.widthMultiplier = 0.1f;



            beam.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 10000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 10000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                beam.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                    var victim = victimBuffer[n];
                    // if (victim.transform.gameObject.GetComponent<NoSleep7>().power != 3)
                    // {
                    ExplosionCreator.CreatePulseExplosion(victim.point, 0.5f, 1, true);
                    victim.transform.SendMessage("Break", BarrelDirection, SendMessageOptions.DontRequireReceiver);
                    victim.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    //  }
                    // phys.rigidbody.AddForceAtPosition(forward * DirectionalForce * phys.rigidbody.mass, hit.point, ForceMode2D.Impulse);
                }

                CameraShakeBehaviour.main.Shake(2, transform.position);
                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(-0.1f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            beam.enabled = false;
            yield return new WaitForSeconds(2.8f);
        }









        private void Nullificator()
        {
            if (upgraded == false)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
                Destroy(this);

            }

        }

        private void rev()
        {
            if (upgraded == false)
            {
                Ruka.gameObject.GetComponent<PhysicalBehaviour>().charge = 60f;

            }

        }
        private void upg()
        {
            if (upgraded == false)
            {
                upgraded = true;

                foreach (var i in Ruka.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.gameObject.AddComponent<ImmortalityBehaviour>();
                }

                ModAPI.CreateParticleEffect("Spark", Ruka.transform.position);
            }
        }


        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }


    }











    public class Shell : MonoBehaviour
    {
        public LimbBehaviour limb;

        GameObject Ruka;
        public void Start()
        {
            Ruka = gameObject;
            limb = Ruka.GetComponent<LimbBehaviour>();
            PhysicalBehaviour physicalBehaviour = limb.PhysicalBehaviour;
            StartCoroutine(lechenie(limb));



        }



        private IEnumerator lechenie(LimbBehaviour limb)
        {
            while (true)
            {
                limb.Person.Consciousness = 0f;
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    limb.CirculationBehaviour.HealBleeding();

                }
                yield return new WaitForSeconds(0.2f);
            }





        }

        public void upg()
        {

            Destroy(this);


        }

    }

    public class ShellAwake : MonoBehaviour
    {
        Core core;
        ShellPunch sp1;
        ShellPunch sp2;
        private GameObject RukaGlow;
        bool s = false;
        Texture2D texture;
        public GameObject Ruka;
        private BoxCollider2D bc;

        bool aura = false;

        public enum Level
        {
            zero,
            one,
            two
        }

        public enum PowerMode
        {

            Laser,
            Barrier,
            Punch,
            Soul

        }

        public PowerMode Mode;
        public Level Lvl;
        void Start()
        {
            Lvl = Level.zero;
            texture = powersprites.it;
            Ruka = gameObject;




            core = this.transform.root.Find("Body").Find("MiddleBody").gameObject.GetComponent<Core>();

            sp1 = this.transform.root.Find("FrontArm").Find("LowerArmFront").GetComponent<ShellPunch>();
            sp2 = this.transform.root.Find("BackArm").Find("LowerArm").GetComponent<ShellPunch>();



            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(4.0f, 4.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;



            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localRotation = Quaternion.identity;

            RukaGlow.transform.localScale = new Vector3(1f, 1f);
            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = powersprites.mask1;
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 1f, 1f, 0f);
            RukaSprite.sortingLayerName = "Top";
            RukaGlow.transform.localRotation = Quaternion.identity;







        }
        void upg()
        {
            if (Lvl == Level.zero)
            {

                GetComponent<LimbBehaviour>().Person.SetBodyTextures(texture);
                GetComponent<LimbBehaviour>().Person.Consciousness = 1f;

                CreateContextMenuOptions();


                core.g();
                ModAPI.Notify("<color=#ffC0cb>Right click on the head to change the current ability</color>");


                foreach (var gameObj in FindObjectsOfType(typeof(soul)) as soul[])
                {
                    ModAPI.CreateParticleEffect("PinkExplosion", gameObj.transform.position);
                    Destroy(gameObj.gameObject);
                }

                Lvl = Level.one;

            }


        }

        private void Use()
        {
            switch (Mode)
            {
                case PowerMode.Barrier:

                    break;
                case PowerMode.Laser:
                    if (Lvl == Level.one)
                    {
                        Ruka.GetComponent<LazerEye>().Pew();
                    }
                    else
                    {
                        Ruka.GetComponent<GunBeh1>().Pew();
                    }


                    break;

            }
        }

        void RoundTwo()
        {
            foreach (var i in Ruka.transform.root.GetComponentsInChildren<SpriteRenderer>())
            {
                i.gameObject.AddComponent<ImmortalityBehaviour>();
                i.material = ModAPI.FindMaterial("VeryBright");


            }

            var items = Global.main.PhysicalObjectsInWorld.ToArray();



            Destroy(Ruka.GetComponent<LazerEye>());
            Ruka.AddComponent<GunBeh1>();

            sp1.ult = true;
            sp2.ult = true;


            ModAPI.CreateParticleEffect("HugeZap", Ruka.transform.position);
            ModAPI.CreateParticleEffect("PinkExplosion", Ruka.transform.position);
            ModAPI.CreateParticleEffect("Vapor", Ruka.transform.position);

            RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 0.1f, 0.1f, 1f);

            for (int i = 0; i < Global.main.PhysicalObjectsInWorld.Count; i++)
            {

                items[i].GetComponent<PhysicalBehaviour>().SendMessage("OnEMPHit", SendMessageOptions.DontRequireReceiver);
                if (items[i].GetComponent<ImmortalityBehaviour>() == null)
                {
                    items[i].GetComponent<Rigidbody2D>().AddForceAtPosition(new Vector2(1f, 1f) * UnityEngine.Random.Range(-4, 4), items[i].transform.position, ForceMode2D.Impulse);
                }


            }



        }

        private void rev()
        {

            switch (Lvl)
            {
                case (Level.zero):

                    if (s == false)
                    {
                        s = true;
                        // ModAPI.Notify("<color=#425292>You have already caused enough pain in this world.");
                        // ModAPI.Notify("<color=#425292>Perish in the void.");
                        StartCoroutine(death(20f, false));
                    }


                    break;
                case (Level.one):
                    if (s == false)
                    {
                        s = true;




                        StartCoroutine(death(70f, true));

                    }
                    break;

                case (Level.two):
                    if (s == false)
                    {
                        s = true;
                        ModAPI.Notify("<color=#425292>I won't fail this time.");
                        var a = Instantiate(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, this.transform.position, Quaternion.identity);
                        a.GetComponent<SpriteRenderer>().color = Color.magenta;
                        a.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");


                    }

                    break;


            }





        }

        private IEnumerator death(float speed, bool impulse)
        {
            Color fin = new Color(0f, 0f, 0f, 0f);


            foreach (var i in Ruka.transform.root.GetComponentsInChildren<SpriteRenderer>())
            {



                while (i.gameObject.activeInHierarchy && i.color != fin)
                {
                    i.color = Color.Lerp(i.color, fin, Time.deltaTime * speed);
                    yield return new WaitForEndOfFrame();
                }
                if (i.GetComponent<Collider2D>() != null)
                {
                    i.GetComponent<Collider2D>().enabled = false;
                }

            }
            if (impulse == true)
            {
                ModAPI.CreateParticleEffect("EnormousExplosion", Ruka.transform.position);
                ModAPI.CreateParticleEffect("PinkExplosion", Ruka.transform.position);
                var items = Global.main.PhysicalObjectsInWorld.ToArray();
                for (int i = 0; i < Global.main.PhysicalObjectsInWorld.Count; i++)
                {
                    items[i].GetComponent<Rigidbody2D>().AddForceAtPosition(new Vector2(1f, 1f) * UnityEngine.Random.Range(-10, 11), items[i].transform.position, ForceMode2D.Impulse);

                }
            }
            ModAPI.Notify("<color=#425292>Don't come back again.");
            Destroy(Ruka.transform.root.gameObject);
            yield return new WaitForEndOfFrame();

        }






        private void CreateContextMenuOptions()
        {
            var cont = this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons;

            cont.Add(new ContextMenuButton("<color=#ffC0cb>Switch ability</color>", "<color=#ffC0cb>Switch ability</color>", "<color=#ffC0cb>Switch ability</color>", () =>
            {

                switch (Mode)
                {
                    case PowerMode.Laser:
                        Mode = PowerMode.Barrier;

                        core.setcolor(new Color(0.1f, 1f, 0.1f, 0.3f));
                        ModAPI.Notify("<color=#ffC0cb>Current Ability: Repulsive field</color>");
                        break;

                    case PowerMode.Barrier:

                        Mode = PowerMode.Punch;
                        core.setcolor(new Color(1f, 0.1f, 0.1f, 0.3f));

                        sp1.toggle();
                        sp2.toggle();
                        ModAPI.Notify("<color=#ffC0cb>Current Ability: Gravity punches</color>");
                        break;
                    case PowerMode.Punch:

                        Mode = PowerMode.Soul;
                        core.setcolor(new Color(1f, 1f, 1f, 0.3f));
                        sp1.toggle();
                        sp2.toggle();
                        aura = !aura;
                        ModAPI.Notify("<color=#ffC0cb>Current Ability: Soul strengthening aura</color>");
                        break;
                    case PowerMode.Soul:

                        Mode = PowerMode.Laser;
                        aura = !aura;
                        core.setcolor(new Color(0.7f, 0f, 0.7f, 0.3f));
                        ModAPI.Notify("<color=#ffC0cb>Current Ability: Activate head to shoot laser beam</color>");
                        break;



                        

                }



            }));
        }



        public void OnTriggerEnter2D(Collider2D other)
        {
            other.gameObject.TryGetComponent(out NoSleep7 hate);

            if ((hate == null || hate.power != 3) && Mode == PowerMode.Barrier)
            {
                other.gameObject.GetComponent<Rigidbody2D>().AddForceAtPosition(other.gameObject.GetComponent<Rigidbody2D>().velocity * -2, other.transform.position, ForceMode2D.Impulse);

                if (other.gameObject.GetComponent<Rigidbody2D>().velocity.magnitude >= 0f & other.gameObject.GetComponent<Rigidbody2D>().velocity.magnitude <= 1)
                {
                    other.gameObject.GetComponent<LimbBehaviour>().Crush();

                }
                ModAPI.CreateParticleEffect("Vapor", Ruka.transform.position);


            }
            if (aura == true)
            {
                other.gameObject.SendMessage("upg", SendMessageOptions.DontRequireReceiver);
            }


        }
        private void Update()
        {
            if (!GetComponent<LimbBehaviour>().Person.IsAlive() && Lvl == Level.one)
            {
                Lvl = Level.two;
                RoundTwo();
            }

        }




    }



    class LazerEye : MonoBehaviour
    {
        LimbBehaviour Limb;









        void Awake()
        {
            Limb = gameObject.GetComponent<LimbBehaviour>();


        }

        public void Pew()
        {
            GameObject LaserObj = Instantiate(ModAPI.FindSpawnable("Blaster Rifle").Prefab.GetComponent<BlasterBehaviour>().Bolt);

            LaserObj.GetComponent<BlasterboltBehaviour>().damage = 200f;
            LaserObj.GetComponent<BlasterboltBehaviour>().TemperatureTarget = 9999f;
            LaserObj.GetComponent<BlasterboltBehaviour>().Trail.startWidth = 0.2f;
            LaserObj.GetComponent<BlasterboltBehaviour>().Trail.endWidth = 0.05f;
            LaserObj.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(1f, 0f, 1f, 0.5f);
            LaserObj.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(1f, 0f, 1f, 0.1f);


            ModAPI.CreateParticleEffect("Vapor", Limb.transform.position);
            LaserObj.transform.position = Limb.transform.position;
            if (Limb.Person.transform.localScale.x < 0)
                LaserObj.transform.eulerAngles = new Vector3(Limb.transform.eulerAngles.x, Limb.transform.eulerAngles.y, Limb.transform.eulerAngles.z + 180);
            else LaserObj.transform.eulerAngles = Limb.transform.eulerAngles;




        }







    }


    public class GunBeh1 : CanShoot
    {

        private GameObject Ruka;
        private PhysicalBehaviour physicalBehaviour;
        private Vector2 barrelPosition = new Vector2(0f, 0f);
        private Vector2 barrelDirection = new Vector2(6, -1);

        private LineRenderer beam;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;

        private bool ready;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];



        public void Start()
        {
            Ruka = gameObject;
            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            beam = components.AddComponent<LineRenderer>();
            beam.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            beam.useWorldSpace = false;
            beam.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            beam.sortingLayerName = "Bottom";


            beam.enabled = false;

            ready = true;



        }
        public void Pew() => Shoot();


        public override void Shoot()
        {
            var pos = BarrelPosition;
            var dir = BarrelDirection;



            if (ready == true)
            {
                StartCoroutine(Fire());
            }







        }




        private IEnumerator Fire()
        {
            const int iterations = 8;
            const float duration = 0.5f;

            const float interval = duration / iterations;

            beam.startColor = Color.magenta;
            beam.endColor = Color.magenta;
            beam.widthMultiplier = 0.21f;



            ready = false;
            beam.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 10000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 10000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                beam.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                    var victim = victimBuffer[n];

                    ExplosionCreator.CreatePulseExplosion(victim.point, 0.5f, 1, true);
                    if (!victim.transform.gameObject.TryGetComponent(out ImmortalityBehaviour imm))
                    {
                        victim.transform.SendMessage("Break", BarrelDirection, SendMessageOptions.DontRequireReceiver);
                        victim.transform.TryGetComponent(out PhysicalBehaviour ph);
                        ph.Temperature += 1000;
                        victim.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    }


                }

                CameraShakeBehaviour.main.Shake(2, transform.position);
                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(-0.1f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            beam.enabled = false;
            yield return new WaitForSeconds(0.6f);
            ready = true;
        }















        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }


    }



    public class ShellPunch : MonoBehaviour
    {
        public GameObject Ruka;
        public GameObject RukaGlow;

        public bool active = false;
        public bool ult = false;
        public void Awake()
        {

            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;
            //RukaGlow.transform.localRotation = Ruka.transform.localRotation;
            RukaGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();



            RukaSprite.sprite = powersprites.brasletz;

            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(0f, 0f, 0f, 0f);
            RukaSprite.sortingLayerName = "Top";

        }

        public void toggle()
        {
            if (active == false)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0.05f);
                active = !active;
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, 0f);
                active = !active;
            }

        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            if ((rb.velocity.magnitude >= 3f & other.gameObject.GetComponent<Undraggable>() == null) && active == true)
            {
                ModAPI.CreateParticleEffect("Vapor", Ruka.transform.position);
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 5;

                if (ult == true)
                {
                    other.gameObject.AddComponent<ShellMassAdd>();
                }
            }

        }







    }


    class ShellMassAdd : MonoBehaviour
    {
        Rigidbody2D rig;
        public void Start()
        {

            rig = this.gameObject.GetComponent<Rigidbody2D>();
            this.gameObject.GetComponent<SpriteRenderer>().color = Color.magenta;
            StartCoroutine(AddMass());
        }

        IEnumerator AddMass()
        {
            while (rig.mass <= 100f)
            {
                yield return new WaitForSeconds(0.2f);
                rig.mass += 5f;


            }

            this.gameObject.TryGetComponent(out LimbBehaviour limb);
            ModAPI.CreateParticleEffect("Vapor", limb.transform.position);
            yield return new WaitForSeconds(0.1f);
            limb.Crush();

        }

    }


    class Core : MonoBehaviour
    {
        GameObject Ruka;
        GameObject RukaGlow;
        SpriteRenderer renderer;
        Color targetColor;
        Color oldcolor;
        float timeleft;
        void Awake()
        {
            Ruka = gameObject;
            renderer = Ruka.GetComponent<SpriteRenderer>();
            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;
            RukaGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();



            RukaSprite.sprite = ModAPI.LoadSprite("textures/Core.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 0f, 1f, 0);
            RukaSprite.sortingLayerName = "Bottom";
        }

        public void g()
        {
            RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 1f, 0.3f);

        }

        public void setcolor(Color color1)
        {
            RukaGlow.GetComponent<SpriteRenderer>().color = color1;
        }

    }


    class bite : MonoBehaviour
    {

        private RaycastHit2D[] ray = new RaycastHit2D[1];



        private bool H()
        {
            var end = Physics2D.Raycast(gameObject.transform.position, transform.root.localScale, 10, LayerMask.GetMask("Objects", "CollidingDebris", "Bounds"));
            var endPos = end.transform == null ? (Vector3)gameObject.transform.position + (Vector3)transform.root.localScale * 10 : (Vector3)end.point;
            var victimCount = Physics2D.LinecastNonAlloc(gameObject.transform.position, endPos, ray, LayerMask.GetMask("Objects", "CollidingDebris", "Bounds"));
            if (victimCount == 0)
            {
                return false;
            }
            return true;

        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            other.gameObject.TryGetComponent(out NoSleep7 hate);
            other.gameObject.TryGetComponent(out LimbBehaviour limb);
            if ((hate == null || hate.power < 2) && limb.IsZombie == false)
            {
                if (H())
                {
                    DistanceJoint2D joint = gameObject.AddComponent<DistanceJoint2D>();
                    joint.maxDistanceOnly = false;
                    joint.enableCollision = true;
                    joint.distance = 0.1f;
                    joint.autoConfigureDistance = true;
                    joint.breakForce = 15f;
                    joint.breakTorque = 15f;
                    joint.anchor = new Vector2(0f, 0f);
                    joint.connectedAnchor = new Vector2(0f, 0f);
                    joint.connectedBody = other.gameObject.GetComponent<Rigidbody2D>();

                    RigidWireBehaviour wire = joint.gameObject.AddComponent<RigidWireBehaviour>();
                    wire.WireWidth = 0f;
                    wire.typedJoint = joint;
                    other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("REANIMATION AGENT"), 1f);
                    other.gameObject.transform.root.Find("Head").gameObject.AddComponent<bite>();
                    ModAPI.CreateParticleEffect("BloodExplosion", gameObject.transform.position);
                }



            }




        }

        private void Nullificator()
        {
            Destroy(this);
        }


    }

    class voidtouch : why
    {
        bool said = false;
        bool said2 = false;
        bool said3 = false;


        public enum PowerMode
        {

            Transformation,
            Punch
  

        }

        public PowerMode Mode = PowerMode.Transformation;


        AudioSource audio;
        AudioClip clip;
        public override string powerName()
        {
            return ("void");
        }
        public override string powerSpriteName()
        {
            return ("braslet4");
        }
        public override string powerSpriteNameUpg()
        {
            return ("braslet4");
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 1f, 0.1f);
        }


        public override void Awake()
        {
            base.Awake();
            audio = Ruka.AddComponent<AudioSource>();
            audio.volume = 2.3f;
            clip = ModAPI.LoadSound("123.wav");


        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            other.gameObject.TryGetComponent(out NoSleep7 hate);
            if (Mode == PowerMode.Transformation)
            {
                
                other.gameObject.TryGetComponent(out LimbBehaviour limb);
                if ((hate == null || hate.power < 2) && limb != null && other.gameObject.transform.root.Find("Head").gameObject.GetComponent<voidhead>() == null)
                {
                    limb.Person.SetBodyTextures(powersprites.voids.PickRandom());
                    other.gameObject.transform.root.Find("Head").gameObject.AddComponent<voidhead>();
                    return;
                }
            }
            else
            {
                other.gameObject.TryGetComponent(out PhysicalBehaviour phys);
                if ((hate == null || hate.power < 2) && phys != null)
                {
                    phys.Disintegrate();
                    ModAPI.CreateParticleEffect("Disintegration", other.gameObject.transform.position);
                }
            }

            if (other.gameObject.GetComponent<Core>() || other.gameObject.GetComponent<ShellAwake>())
            {
                ModAPI.Notify("<color=#ffC0cb>...</color>");
                foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    ModAPI.CreateParticleEffect("Spark", i.gameObject.transform.position);
                    i.Crush();
                }
            }
        }

        public  void Nullificatr()
        {
            if(said2 == false)
            {
                said2 = true;
                audio.PlayOneShot(clip, 1.5f);
                ModAPI.Notify("<color=#5e5e5e>What have you done to me?</color>");
            }
            
        }

        public void FixedUpdate()
        {


            if (gameObject.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0f);
            }


        }

        public override void Nullificator()
        {
            if (said == false)
            {
                said = true;
                StartCoroutine(no());
            }
            
        }
        IEnumerator no()
        {
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>What happened?</color>");
            yield return new WaitForSeconds(1f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>That feeling</color>");
            yield return new WaitForSeconds(2f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>It's like a piece of me has been ripped off</color>");
            yield return new WaitForSeconds(2f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>I can resist it! I am not so easy to defeat!</color>");
            
        }
        public override void upg()
        {
            if(upgraded == false)
            {
                upgraded = true;
                StartCoroutine(u());
            }
           
        }

        private void rev()
        {
            if(said3 == false)
            {
                said3 = true;
                StartCoroutine(k());
            }
        }
        public void Use() => sabil();


      void sabil()
        {
            switch (Mode)
            {
                case PowerMode.Punch:
                    Mode = PowerMode.Transformation;
                    RukaGlow.GetComponent<SpriteRenderer>().sprite = powersprites.braslet4;
                    break;
                case PowerMode.Transformation:
                    Mode = PowerMode.Punch;
                    RukaGlow.GetComponent<SpriteRenderer>().sprite = powersprites.braslet5;
                    break;
            }



        }
        private IEnumerator k()
        {
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                ModAPI.CreateParticleEffect("Flash", i.gameObject.transform.position);
            }

            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>What a fool I've been!</color>");
            yield return new WaitForSeconds(3f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>I gave you</color> <color=#ffC0cb>its </color><color=#5e5e5e>location, got you out of the void, and this is how you repay me?</color>");
            yield return new WaitForSeconds(7f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>Even if you can handle the Shell, how long can you keep </color><color=#ffC0cb>its</color><color=#5e5e5e> true form under lock and key?</color>");
            yield return new WaitForSeconds(7f);
            audio.PlayOneShot(clip,1f);
            ModAPI.Notify("<color=#5e5e5e>Looks like my time is running out.</color>");
            yield return new WaitForSeconds(7f);

            audio.PlayOneShot(clip,2f);
            ModAPI.Notify("<color=#5e5e5e>See you in hell</color>");
            yield return new WaitForSeconds(3f);
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                ModAPI.CreateParticleEffect("Disintegration", i.gameObject.transform.position);
                i.Crush();
            }



        }

        IEnumerator u()
        {
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>After what I did, am I still worthy of this gift?</color>");
            yield return new WaitForSeconds(2f);
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                i.Wince(20f);
                i.BaseStrength = 0.1f;
                i.SendMessage("Nullificatr", SendMessageOptions.DontRequireReceiver);
              ModAPI.CreateParticleEffect("Spark", i.gameObject.transform.position);
                i.CirculationBehaviour.BleedingRate += 1.5f;
  
                    i.CirculationBehaviour.CreateBleedingParticle(i.transform.position + new Vector3(0.05f, -0.05f) * UnityEngine.Random.Range(0.97f, 1.02f), UnityEngine.Random.insideUnitCircle * UnityEngine.Random.Range(-0.4f, 0.4f));
                
            }
            yield return new WaitForSeconds(5f);
            audio.PlayOneShot(clip, 2.3f);
            ModAPI.Notify("<color=#5e5e5e>My </color><color=#ffC0cb>Lord</color><color=#5e5e5e> have mercy.");
            yield return new WaitForSeconds(1f);
            audio.PlayOneShot(clip, 2f);
            ModAPI.Notify("<color=#5e5e5e>I am willing to do anything for your forgiveness");
            yield return new WaitForSeconds(4f);
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                i.Crush();
     
            }




        }
    }
    class voidhead : MonoBehaviour
    {
        public void Awake()
        {


        
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                i.Vitality = 1.5f;
                i.Health = 1.5f;
                i.InitialHealth = 1.5f;
                i.Numbness = 1f;
                i.RegenerationSpeed = 1f;
                i.SendMessage("Nullificatr", SendMessageOptions.DontRequireReceiver);
                i.Wince(20f);
            }


        }









       private void rev()
        {
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                ModAPI.CreateParticleEffect("Disintegration", i.gameObject.transform.position);
                i.PhysicalBehaviour.Disintegrate();
            }
        }

        private void upg()
        {
            
            gameObject.GetComponent<LimbBehaviour>().Crush();
        }


    }




    class fakevoidtouch : why
    {
        public enum PowerMode
        {

            Transformation,
            Punch


        }

        public PowerMode Mode = PowerMode.Transformation;

        public override string powerName()
        {
            return ("void");
        }
        public override string powerSpriteName()
        {
            return ("braslet4");
        }
        public override string powerSpriteNameUpg()
        {
            return ("braslet4");
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 1f, 0.1f);
        }


        public void Use() => sabil();


        void sabil()
        {
            switch (Mode)
            {
                case PowerMode.Punch:
                    Mode = PowerMode.Transformation;
                    RukaGlow.GetComponent<SpriteRenderer>().sprite = powersprites.braslet4;
                    break;
                case PowerMode.Transformation:
                    Mode = PowerMode.Punch;
                    RukaGlow.GetComponent<SpriteRenderer>().sprite = powersprites.braslet5;
                    break;
            }
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            other.gameObject.TryGetComponent(out NoSleep7 hate);
            if (Mode == PowerMode.Transformation)
            {

                other.gameObject.TryGetComponent(out LimbBehaviour limb);
                if ((hate == null || hate.power < 2) && limb != null && other.gameObject.transform.root.Find("Head").gameObject.GetComponent<voidhead>() == null)
                {
                    limb.Person.SetBodyTextures(powersprites.voids.PickRandom());
                    other.gameObject.transform.root.Find("Head").gameObject.AddComponent<voidhead>();
                    return;
                }
            }
            else
            {
                other.gameObject.TryGetComponent(out PhysicalBehaviour phys);
                if ((hate == null || hate.power < 2) && phys != null)
                {
                    phys.Disintegrate();
                    ModAPI.CreateParticleEffect("Disintegration", other.gameObject.transform.position);
                }
            }

            if (other.gameObject.GetComponent<Core>() || other.gameObject.GetComponent<ShellAwake>())
            {
                ModAPI.Notify("<color=#ffC0cb>...</color>");
                foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    ModAPI.CreateParticleEffect("Spark", i.gameObject.transform.position);
                    i.Crush();
                }
            }
        }
        public override void upg()
        {

            gameObject.GetComponent<LimbBehaviour>().Crush();
        }
        private void rev()
        {
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                ModAPI.CreateParticleEffect("Disintegration", i.gameObject.transform.position);
                i.PhysicalBehaviour.Disintegrate();
            }
        }
    }


    public class SwitchPlaces : why
    {
        public override string powerName()
        {
            return ("SwitchPlaces");
        }
        public override string powerSpriteName()
        {
            return ("rukanormal");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaupg");
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 0f,0f);
        }

        public override void Awake()
        {
            base.Awake();
            IsHeadPower = true;
        }


        Vector2 oldpos;
        GameObject victim;
        RaycastHit2D hit2D;
        public void Use()
        {
            if (GetComponent<LimbBehaviour>().Person.transform.localScale.x > 0)
            {
                 hit2D = Physics2D.Raycast(transform.position, transform.right, 500);
            }
            else
            {
                 hit2D = Physics2D.Raycast(transform.position, -transform.right, 500);
            }
                
            if(hit2D){
                if (hit2D.transform.gameObject.GetComponent<LimbBehaviour>() != null)
                {
                    ModAPI.CreateParticleEffect("HugeZap", transform.position);
                    ModAPI.CreateParticleEffect("HugeZap", hit2D.transform.position);
                    oldpos = this.gameObject.GetComponent<LimbBehaviour>().Person.transform.position;
                    this.gameObject.GetComponent<LimbBehaviour>().Person.transform.position = hit2D.transform.gameObject.GetComponent<LimbBehaviour>().Person.transform.position;
                    hit2D.transform.gameObject.GetComponent<LimbBehaviour>().Person.transform.position = oldpos;

                    if (upgraded == true)
                    {
                        hit2D.transform.root.Find("Head").GetComponent<LimbBehaviour>().BreakBone();
                    }
                }
            }
        }



        private void rev()
        {

                this.gameObject.GetComponent<LimbBehaviour>().Health = 0f;
                this.gameObject.GetComponent<LimbBehaviour>().BreakBone();

            

        }


    }





    public class Aura1 : why
    {
        public override string powerName()
        {
            return ("god");
        }
        public override string powerSpriteName()
        {
            return ("rukanormal");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaupg");
        }

    


        public override Color color1()
        {
            return new Color(1f, 1f, 0f, 0f);
        }


        private GameObject halo;
      
        private BoxCollider2D bc;
      

        public override void  Nullificator()
        {
            if (upgraded == false)
            {
                Destroy(halo);
                Destroy(this);

            }

        }

        

        public override void Awake()
        {
            base.Awake();
            IsHeadPower = true;

            halo = new GameObject();
            halo.transform.parent = Ruka.transform;
            halo.transform.localPosition = new Vector3(0f, 0f);
            halo.transform.localScale = gameObject.transform.parent.localScale;
            halo.transform.localRotation = Quaternion.identity;
            var eyeSprite = halo.AddComponent<SpriteRenderer>();

            eyeSprite.sprite = powersprites.halo;
            eyeSprite.material = ModAPI.FindMaterial("VeryBright");
            eyeSprite.color = new Color(0.6f, 0.6f, 0.6f, 0.25f);
            eyeSprite.sortingLayerName = "Top";






            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(4.0f, 4.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;
        }

        public void OnTriggerStay2D(Collider2D other)
        {
            other.gameObject.TryGetComponent(out NoSleep7 hate);

            if ((hate == null || hate.power < 1) && other.gameObject.GetComponent<Undraggable>() == null && other.transform.root != this.transform.root)
            {
                other.gameObject.GetComponent<PhysicalBehaviour>().BurnProgress += 0.01f;

                other.gameObject.GetComponent<LimbBehaviour>().Wince(5f);

            }


        }
        public override void upg()
        {
            if (upgraded == false)
            {

                upgraded = true;
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.gameObject.AddComponent<ImmortalityBehaviour>();
                }
                RukaGlow.GetComponent<SpriteRenderer>().sprite = powersprites.eye1;
                bc.size = new Vector2(12.0f, 12.0f);
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.8f, 0.8f, 0.8f, 0.2f);
                ModAPI.CreateParticleEffect("HugeZap", Ruka.transform.position);



            }
        }
        private void rev()
        {
            if (upgraded == false)
            {

                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.SendMessage("Nullificator", SendMessageOptions.DontRequireReceiver);
                }
                Ruka.gameObject.GetComponent<LimbBehaviour>().Crush();
            }

        }



    }


    public class Aura4 : why
    {

        public override string powerName()
        {
            return ("grav");
        }
        public override string powerSpriteName()
        {
            return ("rukanormal");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaupg");
        }

       


        public override Color color1()
        {
            return new Color(1f, 1f, 0f, 0f);
        }

        public override void Awake()
        {
            base.Awake();
            IsHeadPower = true;
            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(7.0f, 7.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;
        }

        public void OnTriggerEnter2D(Collider2D other)
        {
            other.gameObject.TryGetComponent(out NoSleep7 hate);
            if (hate == null || hate.power != 3)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = other.gameObject.GetComponent<Rigidbody2D>().velocity * -5;
                if (other.gameObject.GetComponent<Rigidbody2D>().velocity.magnitude >= 0f & other.gameObject.GetComponent<Rigidbody2D>().velocity.magnitude <= 1)
                {
                    other.gameObject.GetComponent<LimbBehaviour>().Crush();

                }
                if (upgraded == true)
                {

                    other.gameObject.GetComponent<Rigidbody2D>().mass = 20f;

                }
            }




        }

        private void rev()
        {
            if (upgraded == false)
            {

                foreach (var i in Ruka.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<PhysicalBehaviour>().MakeWeightful();
                    i.gameObject.SendMessage("Nullificator", SendMessageOptions.DontRequireReceiver);
                }
                Ruka.gameObject.GetComponent<LimbBehaviour>().Crush();
            }

        }


        public override void upg()
        {
            if (upgraded == false)
            {
                upgraded = true;
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.gameObject.AddComponent<ImmortalityBehaviour>();
                }
                RukaGlow.GetComponent<SpriteRenderer>().sprite = powersprites.Forgotten;
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.9f, 0.9f, 0.9f, 0.1f);
                ModAPI.CreateParticleEffect("HugeZap", Ruka.transform.position);









            }
        }


    }
    public class Aura5 : why
    {



        public override string powerName()
        {
            return ("ox");
        }
        public override string powerSpriteName()
        {
            return ("rukanormal");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaupg");
        }

       


        public override Color color1()
        {
            return new Color(1f, 1f, 0f, 0f);
        }

        public override void Awake()
        {
            base.Awake();
            IsHeadPower = true;


            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(7.0f, 7.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;

        }

        public void OnTriggerStay2D(Collider2D other)
        {
            other.gameObject.TryGetComponent(out NoSleep7 hate);
            if ((hate == null || hate.power < 1) && other.gameObject.GetComponent<Undraggable>() == null)
            {
                other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BleedingRate += 0.002f;

                other.gameObject.GetComponent<LimbBehaviour>().Wince(2f);

            }



        }





        public void rev()
        {
            Ruka.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BleedingRate += 5f;
        }


    }






}


