﻿using System;
using System.Collections;
using UnityEngine;

namespace Mod
{

    class ImmortalityBehaviour : MonoBehaviour
    {
        LimbBehaviour Limb;
        Liquid blood1;

        private void Awake()
        {
            
            Limb = gameObject.GetComponent<LimbBehaviour>();
            blood1 = Limb.GetOriginalBloodType();
            Limb.IsLethalToBreak = false;
            Limb.ImpactPainMultiplier *= 0.5f;
            Limb.ShotDamageMultiplier *= 0.5f;
        }

        private void Update()
        {
            Limb.Health = Limb.InitialHealth;
            Limb.RegenerationSpeed = 10f;
            Limb.CirculationBehaviour.IsPump = true;
            Limb.Numbness = 0f;
            Limb.Vitality = 0f;
            if (Limb.CirculationBehaviour.GetAmount(blood1) <= 1f)
            {
                Limb.CirculationBehaviour.AddLiquid(blood1, 1.4f);
            }
            Limb.CirculationBehaviour.HealBleeding();
            Limb.Person.AdrenalineLevel = 20f;
            Limb.Person.Consciousness = 1f;
            Limb.Person.PainLevel = 0f;
            Limb.Person.ShockLevel = 0f;
        }

       public void Nullificator()
        {
            Destroy(this);
        }

        public void Nullificatr()
        {
            Destroy(this);
        }
    }
}
