﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Mod
{






    public class Meishu : MonoBehaviour
    {
        SpriteRenderer child;
        public static Type[] ability = new Type[]
        {
            typeof(gravpunch),
            typeof(elecpunch),
            typeof(tempfirepunch),
            typeof(tempcoldpunch),
            typeof(colorpunch),
            typeof(weipunch),
            typeof(exppunch),
            typeof(zombiepunch),
            typeof(slicepunch),
            typeof(bonepunch),
            typeof(drainpunch),
            typeof(painpunch),
            typeof(wincepunch),
            typeof(freezepunch)
            
        };





        public static Sprite[] spr = new Sprite[]
        {
                 powersprites.braslet,
        powersprites.braslet2,
        powersprites.brasletz,
        powersprites.brasletupg,
        powersprites.rukanormal,
        powersprites.rukaupg,
        powersprites.puncho,
        powersprites.punchoupg


    };
        public void Awake()
        {
            child = transform.GetChild(0).gameObject.GetComponent<SpriteRenderer>();
            StartCoroutine(color());

        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            if(other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
               var a = other.gameObject.transform.root.Find("FrontArm").Find("LowerArmFront");
                var b = other.gameObject.transform.root.Find("BackArm").Find("LowerArm");
                if(a.gameObject.GetComponent<randability>() == null)
                {
                   Type abil = ability.PickRandom<Type>();
                    Type abil2 = ability.PickRandom<Type>();
                    a.gameObject.AddComponent(abil);
                    b.gameObject.AddComponent(abil2);
                    float randValue = UnityEngine.Random.value;
                    if (randValue > 0.6) 
                    {
                        a.gameObject.transform.root.localScale *= 1.2f;
                        ModAPI.CreateParticleEffect("FuseBlown", a.transform.position);
                    }
                    else if (randValue > 0.7) 
                    {
                        if (a.gameObject.GetComponent<NoSleep7>() == null)
                        {
                            foreach (var i in a.transform.root.GetComponentsInChildren<LimbBehaviour>())
                            {
                                i.gameObject.AddComponent<NoSleep7>();
                                ModAPI.CreateParticleEffect("FuseBlown", a.transform.position);
                            }
                        }
                    }
                    else if (randValue > 0.9)
                    {
                        if (a.gameObject.GetComponent<ImmortalityBehaviour>() == null)
                        {
                            foreach (var i in a.transform.root.GetComponentsInChildren<LimbBehaviour>())
                            {
                                i.gameObject.AddComponent<ImmortalityBehaviour>();
                                ModAPI.CreateParticleEffect("FuseBlown", a.transform.position);
                            }
                        }
                    }
                }
            }


        }

        private IEnumerator color()
        {
           


            while (true)
            {
                Color fin = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value,0.3f);
                while (this.gameObject.activeInHierarchy && child.color != fin)
                {
                    child.color = Color.Lerp(child.color, fin, Time.deltaTime * 10f);
                    yield return new WaitForEndOfFrame();
                }

                yield return new WaitForEndOfFrame();
            }

        }





    }

        public abstract class randability : MonoBehaviour
        { 
        public GameObject Ruka;
        public GameObject RukaGlow;

        public abstract string powername();

        public float a = UnityEngine.Random.Range(0f, 1f);
        public float b = UnityEngine.Random.Range(0f, 1f);
        public float c = UnityEngine.Random.Range(0f, 1f);


        public virtual void Awake()
        {

            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;
            RukaGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();



            RukaSprite.sprite = Meishu.spr.PickRandom<Sprite>();

            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(a, b, c);
            RukaSprite.sortingLayerName = "Top";

        }

        public void FixedUpdate()
        {


            if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(a, b, c, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0f);
            }


        }

        private void Nullificator()
        {

            Destroy(RukaGlow);
            Destroy(this);



        }

        public void OnCollisionEnter2D(Collision2D other)
        {


            var rb = Ruka.GetComponent<Rigidbody2D>();



            if (rb.velocity.magnitude >= 2f)
            {
                OnHit(other.gameObject);
            }


        }

        public abstract void OnHit(GameObject other);





    }


    class gravpunch : randability
    {
        public override string powername()
        {
            return "gravpunch";
        }

        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out Rigidbody2D rg);
            if(rg != null)
            {
                foreach (var i in other.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.GetComponent<Rigidbody2D>().gravityScale *= -1;
                }
                    
            }
        }

    }


    class elecpunch : randability
    {
        public override string powername()
        {
            return "elecpunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out PhysicalBehaviour rg);
            if (rg != null)
            {
                foreach (var i in other.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.charge += 10f;
                }

            }
        }

    }

    class tempfirepunch : randability
    {
        public override string powername()
        {
            return "tempfirepunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out PhysicalBehaviour rg);
            if (rg != null)
            {
                foreach (var i in other.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.Temperature += 200f;
                }

            }
        }

    }
    class freezepunch : randability
    {
        public override string powername()
        {
            return "freezepunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out LimbBehaviour rg);
            if (rg != null)
            {

                rg.Frozen = true;


            }
        }

    }

    class tempcoldpunch : randability
    {
        public override string powername()
        {
            return "tempcoldpunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out PhysicalBehaviour rg);
            if (rg != null)
            {
                foreach (var i in other.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.Temperature -= 200f;
                }

            }
        }

    }

    class colorpunch : randability
    {
        public override string powername()
        {
            return "colorpunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out SpriteRenderer rg);
            if (rg != null && other.gameObject.GetComponent<Undraggable>() == null)
            {
                foreach (var i in other.transform.root.GetComponentsInChildren<SpriteRenderer>())
                {
                    i.color = new Color(a,b,c);
                }

            }
        }

    }


    class weipunch : randability
    {
        public override string powername()
        {
            return "weipunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out Rigidbody2D rg);
            if (rg != null)
            {

                rg.mass += 20f;
                

            }
        }

    }

    class exppunch : randability
    {
        public override string powername()
        {
            return "exppunch";
        }
        public override void OnHit(GameObject other)
        {
            ExplosionCreator.CreatePulseExplosion(transform.position, 1f, 1f, true, true);
        }

    }
    class zombiepunch : randability
    {
        public override string powername()
        {
            return "zombiepunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out LimbBehaviour rg);
            if (rg != null)
            {

                rg.IsZombie = true;


            }
        }

    }
    class slicepunch : randability
    {
        public override string powername()
        {
            return "slicepunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out LimbBehaviour rg);
            if (rg != null)
            {

                rg.Slice();


            }
        }

    }

    class bonepunch : randability
    {
        public override string powername()
        {
            return "bonepunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out LimbBehaviour rg);
            if (rg != null)
            {

                rg.BreakBone();


            }
        }

    }
    class drainpunch : randability
    {
        public override string powername()
        {
            return "drainpunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out LimbBehaviour rg);
            if (rg != null)
            {

                rg.CirculationBehaviour.Drain(1f);


            }
        }

    }

    class painpunch : randability
    {
        public override string powername()
        {
            return "painpunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out LimbBehaviour rg);
            if (rg != null)
            {

                rg.Person.AddPain(200f);


            }
        }

    }
    class wincepunch : randability
    {
        public override string powername()
        {
            return "wincepunch";
        }
        public override void OnHit(GameObject other)
        {
            other.TryGetComponent(out LimbBehaviour rg);
            if (rg != null)
            {

                rg.Person.Wince(300f);


            }
        }

    }

}