﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Mod
{
    public class Spike : MonoBehaviour
    {

        private GameObject Ruka;

        private GameObject RukaGlow;

        public bool upgraded = false;

       

        public void Awake()
        {
            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;

            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = ModAPI.LoadSprite("textures/spiker55.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 0f, 1f, 0f);
            RukaSprite.sortingLayerName = "Top";





            var component = Ruka.GetComponent<PhysicalBehaviour>();
            var chelovek = ModAPI.FindPhysicalProperties("Human");
            chelovek.Sharp = true;
            chelovek.SharpAxes = new[]
            {
                                    new SharpAxis(Vector2.down, 0f, 0.55f, false, true),
                                };
            component.Properties = chelovek;


        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            if(upgraded == true)
                {


                other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("????"), 1.4f);
            }
            
        }

        private void upg()
        {
            if (upgraded == false)
            {

                upgraded = true;

       
                foreach (var i in Ruka.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.gameObject.AddComponent<ImmortalityBehaviour>();
                }

                ModAPI.CreateParticleEffect("Spark", Ruka.transform.position);
                RukaGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.5f, 0.5f, 0.25f);





               

            }
        }

    }
    }